#include "StdAfx.h"
#include ".\8imageframedraw.h"
#include "ImageProxy.h"

#include "ScriptletConstant.h"

REGISTER_COMPONENT_CREATOR(SCRIPTLET_8IMAGEFRAMEDRAW_NODE, C8ImageFrameDraw);
IMPLEMENT_RTTI(C8ImageFrameDraw, CDrawingShape);

C8ImageFrameDraw::C8ImageFrameDraw()
{
	m_MarginBackground.left = m_MarginBackground.top = m_MarginBackground.right = m_MarginBackground.bottom = 0;
}

C8ImageFrameDraw::~C8ImageFrameDraw(void)
{
}
BOOL C8ImageFrameDraw::GetOrginPreferredSize(LPSIZE lpSize)
{
	lpSize->cx = 0;
	lpSize->cy = 0;
	return TRUE;
}
void C8ImageFrameDraw::GetRectDrawDest(LPRECT prcDrawDest)
{
	CRect rcDrawDest;
	this->GetBounds(&rcDrawDest);

	/*rcDrawDest.DeflateRect(m_pImage_LeftTop->GetWidth(), 
		m_pImage_CenterTop->GetHeight(),
		m_pImage_RightBottom->GetWidth(), 
		m_pImage_CenterBottom->GetHeight());*/

	if (m_pImage_LeftTop.get() != NULL)
	{
		rcDrawDest.left += max(m_pImage_LeftTop->GetWidth(), m_pImage_LeftBottom->GetWidth());
		rcDrawDest.top += m_pImage_CenterTop->GetHeight();
		rcDrawDest.right -= max(m_pImage_RightBottom->GetWidth(), m_pImage_RightTop->GetWidth());
		rcDrawDest.bottom -= m_pImage_CenterBottom->GetHeight();
	}	

	::CopyRect(prcDrawDest, &rcDrawDest);
}
void C8ImageFrameDraw::DrawComponent( HDC hDC )
{
	CRect rcBackground;
	this->GetBounds(&rcBackground);
	rcBackground.left += m_MarginBackground.left;
	rcBackground.top += m_MarginBackground.top;
	rcBackground.right -= m_MarginBackground.right;
	rcBackground.bottom -= m_MarginBackground.bottom;
	FillSolidRect(hDC, &rcBackground, m_clrBg);
	
	if (m_pImage_LeftTop.get() == NULL)
	{
		return ;
	}
	CRect rcDrawDest;
	this->GetBounds(&rcDrawDest);


	CRect rcSrc(0, 
				0, 
				m_pImage_LeftTop->GetWidth(), 
				m_pImage_LeftTop->GetHeight());
	CRect rcDest(	0, 
					0, 
					m_pImage_LeftTop->GetWidth(), 
					m_pImage_LeftTop->GetHeight());
	m_pImage_LeftTop->DrawImage(hDC, &rcSrc, &rcDest);

	rcSrc.SetRect(	0, 
					0, 
					m_pImage_CenterTop->GetWidth(), 
					m_pImage_CenterTop->GetHeight());
	rcDest.SetRect(	m_pImage_LeftTop->GetWidth(), 
					0, 
					rcDrawDest.right - m_pImage_RightTop->GetWidth()+1, 
					m_pImage_CenterTop->GetHeight());
	m_pImage_CenterTop->DrawImage(hDC, &rcSrc, &rcDest);

	rcSrc.SetRect(	0, 
					0, 
					m_pImage_RightTop->GetWidth(), 
					m_pImage_RightTop->GetHeight());
	rcDest.SetRect(	rcDrawDest.right - m_pImage_RightTop->GetWidth(), 
					0, 
					rcDrawDest.right, 
					m_pImage_LeftTop->GetHeight());
	m_pImage_RightTop->DrawImage(hDC, &rcSrc, &rcDest);

	rcSrc.SetRect(	0, 
					0, 
					m_pImage_LeftVCenter->GetWidth(), 
					m_pImage_LeftVCenter->GetHeight());
	rcDest.SetRect(	0, 
					m_pImage_LeftTop->GetHeight(), 
					m_pImage_LeftTop->GetWidth(), 
					rcDrawDest.bottom - m_pImage_LeftBottom->GetHeight());
	m_pImage_LeftVCenter->DrawImage(hDC, &rcSrc, &rcDest);

	rcSrc.SetRect(	0, 
					0, 
					m_pImage_RightVCenter->GetWidth(), 
					m_pImage_RightVCenter->GetHeight());
	rcDest.SetRect(	rcDrawDest.right - m_pImage_RightTop->GetWidth(), 
					m_pImage_LeftTop->GetHeight(), 
					rcDrawDest.right,
					rcDrawDest.bottom - m_pImage_LeftBottom->GetHeight());
	m_pImage_RightVCenter->DrawImage(hDC, &rcSrc, &rcDest);

	rcSrc.SetRect(	0, 
					0, 
					m_pImage_LeftBottom->GetWidth(), 
					m_pImage_LeftBottom->GetHeight());
	rcDest.SetRect(	0, 
					rcDrawDest.bottom - m_pImage_LeftBottom->GetHeight(),
					m_pImage_LeftTop->GetWidth(),
					rcDrawDest.bottom);
	m_pImage_LeftBottom->DrawImage(hDC, &rcSrc, &rcDest);

	rcSrc.SetRect(	0, 
					0, 
					m_pImage_CenterBottom->GetWidth(), 
					m_pImage_CenterBottom->GetHeight());
	rcDest.SetRect(	m_pImage_LeftTop->GetWidth(), 
					rcDrawDest.bottom - m_pImage_LeftBottom->GetHeight(),
					rcDrawDest.right - m_pImage_RightTop->GetWidth() + 1,
					rcDrawDest.bottom);
	m_pImage_CenterBottom->DrawImage(hDC, &rcSrc, &rcDest);

	rcSrc.SetRect(	0, 
					0, 
					m_pImage_RightBottom->GetWidth(), 
					m_pImage_RightBottom->GetHeight());
	rcDest.SetRect(	rcDrawDest.right - m_pImage_RightTop->GetWidth(), 
					rcDrawDest.bottom - m_pImage_LeftBottom->GetHeight(),
					rcDrawDest.right,
					rcDrawDest.bottom);
	m_pImage_RightBottom->DrawImage(hDC, &rcSrc, &rcDest);
}
